<stylesheet
	xmlns="http://www.w3.org/1999/XSL/Transform"
	xmlns:seaf="http://seaf.sf.net/seaf"
	xmlns:per="http://seaf.sf.net/seaf-persistence"
	version="2.0">
<import href="functions/SeafPersistenceBusinessFunctions.xsl" />
<output method="text" />

<template match="//per:persistence//per:enum-def">
	<variable name="full-type" select="per:entity-full-type(.)" />
	<variable name="class" select="seaf:type-class($full-type)" />
	<variable name="dir" select="seaf:type-dir($full-type)" />
	<variable name="package" select="seaf:type-package($full-type)" />

<result-document href="{$dir}/{$class}.java">

<text />/**
 * GENERATED BY Seaf Persistence Generator. DO NOT EDIT.
 */
package <value-of select="$package" />;

import java.util.Arrays;

import net.sf.seaf.persistence.EnumEntity;
import net.sf.seaf.util.HashCodeUtils;
import net.sf.seaf.util.ToStringUtils;

/**
 * <value-of select="$class" /> persistent enumeration.<text />
	<if test="per:description">
 * &lt;p>
 * <value-of select="per:description" />
	</if>
 */
public class <value-of select="$class" /> implements EnumEntity&lt;<text />
	<value-of select="$class" />.Code>,
		java.io.Serializable {

	private Code code;

	public static enum Code {<text />
	<for-each select="per:enum-value">
		<text>
</text>
		<if test="@description">
		/**
		 * <value-of select="@description" />
		 */<text />
		</if>
		<text>
		</text>
		<value-of select="@code" />
		<if test="not(position()=last())">,</if>
	</for-each>
	}

	/**
	 * Default constructor.
	 */
	public <value-of select="$class" />() {
	}

	/**
	 * Full constructor.
	 * 
	 * @param code
	 *            The code
	 */
	public <value-of select="$class" />(Code code) {
		this.code = code;
	}

	// getters and setters

	/**
	 * Returns the code.
	 * 
	 * @return code
	 */
	public Code getCode() {
		return code;
	}

	/**
	 * Sets the code.
	 * 
	 * @param code
	 *            The code
	 */
	public void setCode(Code code) {
		this.code = code;
	}

	/**
	 * Returns the primary key, i.e. the code.
	 * 
	 * @return The primary key (code)
	 */
	public Code getId() {
		return getCode();
	}

	/**
	 * Returns the primary key, i.e. the code.
	 * 
	 * @param code
	 *            The primary key (code)
	 */
	public void setId(Code id) {
		setCode(id);
	}

	// standard Java methods

	/**
	 * Return the values of the business key properties of the bean.
	 * 
	 * @return Object[]
	 */
	private Object[] businessKeyValues() {
		return new Object[] { getCode() };
	}

	@Override
	public boolean equals(Object object) {
		if (this == object)
			return true;
		if (null == object)
			return false;
		if (!(getClass().equals(object.getClass())))
			return false;
		if (!<value-of select="$class" />.class.getSuperclass().equals(Object.class)
				&amp;&amp; !super.equals(object))
			return false;
		final <value-of select="$class" /> that = (<value-of select="$class" />) object;
		return Arrays.equals(this.businessKeyValues(), that.businessKeyValues());
	}

	@Override
	public int hashCode() {
		int superHashCode = 0;
		if (!<value-of select="$class" />.class.getSuperclass().equals(Object.class))
			superHashCode = super.hashCode();
		return HashCodeUtils.hashCodeFor(superHashCode, businessKeyValues());
	}

	@Override
	public String toString() {
		ToStringUtils u = new ToStringUtils(getClass(), "");
		u.addProperty("code", getCode());
		return u.toString();
	}

	// static factory methods<text />

	<for-each select="per:enum-value">

	/**
	 * Returns the <value-of select="$class" /> with code <text />
	 	<value-of select="@code" />.
	 * 
	 * @return The <value-of select="$class" /> with code <text />
	 	<value-of select="@code" />
	 */
	public static <value-of select="$class" /><text> </text>
		<value-of select="@code" />() {
		return new <value-of select="$class" />(Code.<value-of select="@code" />);
	}<text />
	</for-each>

	private static final long serialVersionUID = 1L;

}
<text />

</result-document>
</template>

</stylesheet>
