package net.sf.seaf.persistence;

import java.io.Serializable;

/**
 * The common interface of all persistent entities.
 */
public interface Entity<PK extends Serializable> {

	/**
	 * Return the primary key value.
	 * 
	 * @return The primary key value
	 */
	PK getId();

	/**
	 * Set the primary key value.
	 * 
	 * @param id
	 *            The primary key value
	 */
	void setId(PK id);

}
